
#include <sys/audio.h>
#include <sys/ioctl.h>
#include <sys/fcntl.h>
#include "common.h"
#include "sound.h"

/*
 * Sound-specific stuff for VOXware compatible audio devices.
 */

int sound_init(int audiofd, layer *info, int stereo) {
    int		samplefrq = (int)
		    (s_freq[info->version]
		    [info->sampling_frequency] * 1000.0);
    int		tmp;

    /* Sample size/precision? */
    tmp = 16;

    if (ioctl(audiofd, SOUND_PCM_WRITE_BITS, &tmp) == -1) {
	perror("SOUND_PCM_WRITE_BITS");
	return(1);
    }

    if (tmp != 16) {
	perror("Soundcard doesn't support 16 bit sound!");
	return(1);
    }

    /* Mono/stereo */
    tmp = stereo;

    if (ioctl(audiofd, SOUND_PCM_WRITE_CHANNELS, &tmp) == -1) {
	perror("SOUND_PCM_WRITE_CHANNELS");
	return(1);
    }

    /*
     * Frequency, this has to be set after the number of channels
     * is selected otherwise SBPros fuck up
     */
    if (ioctl(audiofd, SOUND_PCM_WRITE_RATE , &samplefrq) == -1) {
	perror("SOUND_PCM_WRITE_RATE");
	return(1);
    }

    /*
     * Improves transport of sample data to audio device
     */
//  qnx: /usr/include/sys/audio.h says no :( 
//
//  tmp=12;
//  ioctl(audiofd, SNDCTL_DSP_SETFRAGMENT, &tmp);
//   /*
//    * Raise the priority of audio device operations. This
//    * only works if mpeg3play runs as root.
//    */
//  nice(-11);

    return(0);
}

int sound_open() {
    return(open("/dev/dsp", O_WRONLY));
}

int sound_close(int audiofd) {
    return(close(audiofd));
}

int sound_write(int audiofd, const void *buffer, size_t count) {
	int rc;
    rc=write(audiofd, buffer, count);
//  without this output is very jerky
	ioctl(audiofd, SOUND_FLUSH);
	return (rc);
}
